//<c>   Copyright 1999-2000 by Gerry J. Danen; all rights reserved.

//<t>   Match a Name with the Number 666 - Numerology

#include"gd_tools.h"


#define pgVERS_ "V1.10"
#define pgTITL_ "Match a Name with the Number 666 - Numerology"
#define pgCOPR_ "1999"


UCHAR   sName[256], uName[256] ;
ULONG   t[3]= {0,0,0};
BOOL    bMatch ;


void    check_for_match( STRING s )
{
    if ( strstr(s, "666") )
        bMatch = TRUE ;
}


void    total( int which )
{
    static UCHAR prt[81] ;

    printf( "%6ld%5lX%5lo %8s  ", t[which], t[which], t[which], "" );

    sprintf( prt, "%10ld ", t[which] );
    check_for_match( prt );
    sprintf( prt, "%10lX ", t[which] );
    check_for_match( prt );
    sprintf( prt, "%10lo ", t[which] );
    check_for_match( prt );

    if ( which == 2 )
    {
        printf( "%4ld", t[0] );
        sprintf( prt, "%10ld ", t[0] );
        check_for_match( prt );
    }
}


void    letter( int c, int which )
{
    UINT        bit_pattern ;
    UCHAR       bitties[41] ;

    t[which] = t[which] + (ULONG) c ;

    bit_pattern = (UINT) c ;
    Binary2Str( bit_pattern, bitties, NO );
    printf( "%c %4d   %02X  %03o %s  ", c, c, c, c, &bitties[8] );
    if ( which == 2 )
    {
        if ( INRANGE(c,'A','Z') )
        {
            int n = c+1-'A' ;
            printf( "%4d", n );
            t[0] = t[0] + n ;
        }
        else
            printf( "    " );
    }
}


void    main( void )
{
    int         l, x ;
    STRING      title = "   Dec  Hex  Oct Binary    ", ul = " ----- ---- ---- --------  " ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(1);

    while ( TRUE )
    {
        t[0] = t[1] = t[2] = 0 ;                // reset totals
        bMatch = FALSE ;

        fprintf( stderr, "\nEnter a name, or just ENTER to quit."
                "\nIf you don't want spaces (or any other characters) to be counted,\ndon't type them!"
                "\nEnter the name: " );
        gets( sName );
        st_trim( sName );                       // remove leading & trailing spaces
        l = strlen(sName);
        if ( l < 1 )
            exit( 0 );

        ST_CPY( uName, sName);
        strupr( uName );

        printf( "\n\nName: %s\n%s%s\n", sName, title, title );
        printf( "%s%s\n", ul, ul );

        LOOP( x, 0, l-1, 1 )
        {
            letter( (int) sName[x], 1 );
            letter( (int) uName[x], 2 );
            printf( "\n" );
        }

        printf( "%s%s\n", ul, ul );
        total( 1 );
        total( 2 );
        printf( " *** Totals ***" );
        if ( bMatch )
            printf( "\n\a --- MATCH FOUND! ---\a\n" );
        else
            printf( "\n" );
    }
}
